SystemOrganization addCategory: #ConfigurationOfPathObjects!

Object subclass: #ConfigurationOfPathObjects
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfPathObjects'!

!ConfigurationOfPathObjects class methodsFor: 'development support' stamp: 'ls 2/28/2014 14:05:14.699'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfPathObjects class methodsFor: 'private' stamp: 'ls 2/28/2014 14:05:14.902'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfPathObjects class methodsFor: 'private' stamp: 'ls 2/28/2014 14:05:15'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfPathObjects class methodsFor: 'private' stamp: 'ls 2/28/2014 14:05:15.097'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfPathObjects class methodsFor: 'metacello tool support' stamp: 'ls 2/28/2014 14:05:15.207'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfPathObjects class methodsFor: 'loading' stamp: 'ls 2/28/2014 14:05:15.305'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfPathObjects class methodsFor: 'loading' stamp: 'ls 2/28/2014 14:05:15.404'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfPathObjects class methodsFor: 'loading' stamp: 'ls 2/28/2014 14:05:15.501'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfPathObjects class methodsFor: 'accessing' stamp: 'ls 2/28/2014 14:05:15.601'!
project

	^self new project! !

!ConfigurationOfPathObjects class methodsFor: 'development support' stamp: 'ls 2/28/2014 14:05:14.803'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfPathObjects methodsFor: 'baselines' stamp: 'ls 2/28/2014 14:35:16.645'!
baseline100: spec 
	<version: '1.0-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
		spec repository: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/PathObjects'.    
		spec
			package: 'PathObjects-Benchmarks';                    
			package: 'PathObjects-Core';
			package: 'PathObjects-Diagram';
			package: 'PathObjects-Export';
			package: 'PathObjects-Graph';
			package: 'PathObjects-Widgets'.
		spec
			group: 'default' with: #('Core');
			group: 'Core' with: #('PathObjects-Core', 'PathObjects-Diagram', 'PathObjects-Graph',
				'PathObjects-Widgets', 'PathObjects-Export', 'PathObjects-Benchmarks').
	].! !

!ConfigurationOfPathObjects methodsFor: 'accessing' stamp: 'ls 2/28/2014 14:05:14.251'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfPathObjects methodsFor: 'accessing' stamp: 'ls 2/28/2014 14:05:14.583'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfPathObjects methodsFor: 'symbolic versions' stamp: 'ls 2/28/2014 14:33:39.639'!
stable: spec
	<symbolicVersion: #'stable'>
	
	spec for: #'common' version: '1.0'.! !

!ConfigurationOfPathObjects methodsFor: 'versions' stamp: 'ls 2/28/2014 14:34:00.369'!
version10: spec 
	<version: '1.0' imports: #('1.0-baseline') >
	
	spec for: #common do: [
		spec blessing: #release.
		spec 
			package: 'PathObjects-Core' with: 'PathObjects-Core-ls.118';
			package: 'PathObjects-Diagram' with: 'PathObjects-Diagram-ls.258';
			package: 'PathObjects-Export' with: 'PathObjects-Export-ls.9';
			package: 'PathObjects-Graph' with: 'PathObjects-Graph-ls.41';
			package: 'PathObjects-Widgets' with: 'PathObjects-Widgets-ls.37';
			package: 'PathObjects-Benchmarks' with: 'PathObjects-Benchmarks-ls.15'.
	].! !
